function log(msg) {
    if (window.cc && window.cc.error) {
        window.cc.error(msg);
    } else if (window.cc && window.cc.warn) {
        window.cc.warn(msg);
    } else {
        console.log(msg);
    }
}

function in_frame() {
    try {
        return window.top !== window.self;
    } catch (e) {
        return true;
    }
}

function has_sub_frame() {
    return document.getElementsByTagName("iframe").length > 0;
}

function isLaya() {
    return !!window.Laya
}

function is_cocos() {
    return !!window.cc;
}

function is_egret() {
    return !!window.egret;
}

function get_infos() {
    return 'is_egret: ' + is_egret() + ', is_coos: ' + is_cocos() + ', isLaya: ' + isLaya() + ', has_sub_frame: ' +
        has_sub_frame() + ', in_frame: ' + in_frame() + ', in_game: ' + is_game();
}

function is_game() {
    return is_egret() || is_cocos() || isLaya() || !has_sub_frame();
}

function _tt_get_speed() {
    let speed = window.__speed || 1.0;
    const enable = window.__enable_speed !== false;
    if (!enable) {
        speed = 1.0;
    }
    return speed;
}

function _tt_update_scale() {
    console.log('---------------------------------------------, speed: ' + _tt_get_speed())
    console.log('laya.systemTimer: ' + Laya.timer)
    Laya.timer.scale = _tt_get_speed()
}

(function(){
    console.log('--laya.js begin for url: ' + location.toString());
    window.setSpeed = function (speed) {
        console.log('---------- setSpeed called')
        window.__speed = speed;
        _tt_update_scale()
    };

    window.setEnable = function (enable) {
        console.log('------------ setEnable called')
        window.__enable_speed = enable;
        _tt_update_scale()
    };

    console.log('--laya.js finish for url: ' + location.toString());
})()